diff --git a/FHEM/01_FHEMWEB.pm b/FHEM/01_FHEMWEB.pm
index 5525e40..b282803 100755
--- a/FHEM/01_FHEMWEB.pm
+++ b/FHEM/01_FHEMWEB.pm
@@ -2474,8 +2474,6 @@ FW_FlushInform($)
   my $c = $hash->{CD};
   print $c $hash->{INFORMBUF};
   $hash->{INFORMBUF}="";
-
-  CommandDelete(undef, $name);
 }
 
 ###################
diff --git a/www/pgm2/fhemweb.js b/www/pgm2/fhemweb.js
index 711a9af..7720ede 100644
--- a/www/pgm2/fhemweb.js
+++ b/www/pgm2/fhemweb.js
@@ -1,5 +1,7 @@
 /*************** LONGPOLL START **************/
 var FW_pollConn;
+//The number of the next line in FW_pollConn.responseText to parse
+var FW_curLine;
 
 function
 FW_cmd(arg)     /* see also FW_devState */
@@ -12,24 +14,49 @@ FW_cmd(arg)     /* see also FW_devState */
 function
 FW_doUpdate()
 {
-  if(FW_pollConn.readyState != 4 || FW_pollConn.status != 200)
+  if(FW_pollConn.readyState == 2 && FW_pollConn.status != 200) {
+    var errdiv = document.createElement('div');
+    errdiv.innerHTML = "Connection lost, reconnecting in 5 seconds...";
+    errdiv.setAttribute("id","connect_err");
+    errdiv.setAttribute("style","background-color: #000000; color: #FFFFFF; position:absolute; top:0px; left:40px; z-index: 10;");
+    document.body.appendChild(errdiv);
+    setTimeout("FW_longpoll()", 5000);
+    return; // some problem connecting
+  }
+  if(FW_pollConn.readyState < 3)
     return;
+  //alert(FW_pollConn.responseText);
   var lines = FW_pollConn.responseText.split("\n");
-  for(var i=0; i < lines.length; i++) {
+  //Pop the last (maybe empty) line after the last "\n"
+  //We wait until it is complete, i.e. terminated by "\n"
+  lines.pop();
+
+  for(var i=FW_curLine; i < lines.length; i++) {
     var d = lines[i].split(";", 3);    // Complete arg
+    //alert("lines: " + lines[i]);
     if(d.length != 3)
       continue;
     var el = document.getElementById(d[0]);
     if(el)
       el.innerHTML=d[2];
   }
-  FW_pollConn.abort();
-  FW_longpoll();
+  //Next time, we continue at the next line
+  FW_curLine = lines.length;
+
+  //Connection closed -> reconnect
+  if(FW_pollConn.readyState == 4)
+    FW_longpoll();
 }
 
 function
 FW_longpoll()
 {
+  var errdiv = document.getElementById("connect_err");
+  if(errdiv)
+    document.body.removeChild(errdiv);
+
+  FW_curLine = 0;
+
   FW_pollConn = new XMLHttpRequest();
   var room="room=all";
   var sa = document.location.search.substring(1).split("&");
